/**
	 * A function to create data from database
	 * @param {string} full name of tag
    * @param {string} value of tag
	 */
function makeDataFromDatabase(in_TagName, in_Value) {
   var Day = new iDate(); // create an iDate object, with the current date and time
   var l_oSql = IR.GetDatabase(); //Create a variable and assign it a system database object
   //variables  
   var l_oDate;
   var l_sTagID;
   var l_sTagName;
   var l_nGetDate;
   var l_nValue;
   var l_sMakeDate;
   
   if (in_Value == "day") {
      // create an iDate object with last day date
      l_oDate = new iDate(Day.year, Day.month, (Day.date - 1), Day.hours, Day.minutes, Day.seconds, Day.ms);
   }
   else if (in_Value == "month") {
      // create an iDate object with last month date
      l_oDate = new iDate(Day.year, (Day.month - 1), Day.date, Day.hours, Day.minutes, Day.seconds, Day.ms); 
   }
   // created a variable and assigned it a sql.Request object, the request body was specified in brackets
   var l_oDataByDate = l_oSql.Request('SELECT TAG_ID, DATETIME, VALUE FROM INTEGER_TAG_HISTORY WHERE DATETIME > '+l_oDate.value+' ORDER BY DATETIME DESC'); 
   //Limits the search to the last 1000 records
   var l_oDataByDateRows = l_oDataByDate.Rows;
   if (l_oDataByDateRows > 1000) l_oDataByDateRows = 1000; 
   if (l_oDataByDateRows) {
      for (var j = 0; j < l_oDataByDateRows; j++) {
         l_sTagID = l_oDataByDate.GetRowValue(0,j); //get Tag ID 
         l_nGetDate = l_oDataByDate.GetRowValue(1,j); //Get the date of the tag change
         l_nValue = l_oDataByDate.GetRowValue(2,j);  //Get the value of the tag
         
         // create an iDate object with date of the tag change
         var date = new iDate(l_nGetDate);
         //create string with date and time
         l_sMakeDate = '';
         if (date.date < 10)
            l_sMakeDate += "0" + date.date + ".";
         else l_sMakeDate += date.date + ".";
         if (date.month < 10)
            l_sMakeDate += "0" + date.month + "." + date.year + " [";
         else l_sMakeDate += date.month + "." + date.year + " [";  
         if (date.hours < 10)
            l_sMakeDate += "0" + date.hours + ":";   
         else l_sMakeDate += date.hours + ":";   
         if (date.minutes < 10)
            l_sMakeDate += "0" + date.minutes + ":"; 
         else l_sMakeDate += date.minutes + ":";   
         if (date.seconds < 10)
            l_sMakeDate += "0" + date.seconds + "] ";
         else l_sMakeDate += date.seconds + "] ";
         
         // created a variable and assigned it a sql.Request object, the request body was specified in brackets
         var l_oDataByTagID = l_oSql.Request('SELECT NAME, TAG_ID FROM TAGS_PASSPORT WHERE TAG_ID = '+l_sTagID); 
         var l_oDataByTagIDRows = l_oDataByTagID.Rows;
         for (var k = 0; k < l_oDataByTagID.Rows; k++) {  //add to string name of tag and tag value
            l_sTagName = l_oDataByTagID.GetRowValue(0,k);
            l_sMakeDate += l_sTagName + " is " + l_nValue;  
            IR.SetVariable("Server.Tags.Data", l_sMakeDate);  //write value in server tag          
            
         }
      }
      l_oSql.Close()  //Complete the work with the database
   }     
}
// Set global listener
IR.SetGlobalListener(IR.EVENT_GLOBAL_TAG_CHANGE, function(in_sName, in_sValue)
{
   if (in_sValue == "day" || in_sValue == "month")  
      //call function to create data from database
      makeDataFromDatabase(in_sName, in_sValue);
});

// Subscribe to tags
IR.SubscribeTagChange("Server.Channels.Month");
IR.SubscribeTagChange("Server.Channels.Day");